#ifndef __LOGGER_H
#define __LOGGER_H

#include <stdio.h>
#include <stdarg.h>

class MessagePool;

class Logger
{
public:
    Logger(const char *logname, int threshold);
    ~Logger();
    void error(const char *txt, ...);
    void debug(const char *txt, ...);
    void warning(const char *txt, ...);
    void note(const char *txt, ...);
    void gameMsg(const char *txt, ...);
    void renderGameMsg(bool r)
    {
        rendergamemsg = r;
    }

    void indent();
    void unindent();
    void setMsgPool(MessagePool *mp)
    {
        msgpool = mp;
    }
private:
    FILE *logfile;
    int indentsteps, threshold;
    char indentString[64];
    MessagePool *msgpool;
    bool rendergamemsg;
};

extern Logger *logger;

#endif

