// mode: -*- C++ -*-
#ifndef __PROJECTILEANIM_H
#define __PROJECTILEANIM_H

#ifdef _MSC_VER
# pragma warning (disable: 4503)
# pragma warning (disable: 4786)
#endif

#include <map>
#include "SDL.h"

#include "actioneventqueue.h"

class Weapon;
class UnitOrStructure;
class UnitAndStructurePool;
class L2Overlay;

class ExplosionAnim : public ActionEvent
{
public:
    ExplosionAnim(Uint32 p, UnitAndStructurePool* uspool, Uint16 pos,
                  Uint32 startimage, Uint8 animsteps, Sint8 xoff, Sint8 yoff);
    ~ExplosionAnim();
    void run();
private:
    UnitAndStructurePool *uspool;
    L2Overlay *l2o;
    Uint16 pos;
    Uint8 animsteps;
    std::multimap<Uint16, L2Overlay*>::iterator l2entry;
};

class ProjectileAnim : public ActionEvent
{
public:
    ProjectileAnim(Uint32 p, Weapon *weap, UnitOrStructure* owner, Uint16 dest, Uint8 subdest, UnitAndStructurePool *uspool);
    ~ProjectileAnim();
    void run();
private:
    Weapon* weap;
    UnitOrStructure* owner;
    UnitOrStructure* target;
    Uint16 dest;
    Uint8 subdest;
    Sint8 xoffset;
    Sint8 yoffset;
    UnitAndStructurePool *uspool;
    //Sint32 xmod, ymod;
    L2Overlay *l2o;
    std::multimap<Uint16, L2Overlay*>::iterator l2entry;
    double xdiff, ydiff;
    double xmod, ymod, rxoffs, ryoffs;
    bool heatseek,inaccurate;
    Uint8 facing;
};

#endif
