#include <ctype.h>
#include <stdio.h>
#include "common.h"

std::vector<char*> splitList(char* line, char delim)
{
    std::vector<char*> retval;
    char* tmp;
    Uint32 i,i2;
    tmp = NULL;
    if (line != NULL) {
        tmp = new char[16];
        memset(tmp,0,16);
        for (i=0,i2=0;line[i]!=0x0;++i) {
            if ( (i2>=16) || (tmp != NULL && (line[i] == delim)) ) {
                //fprintf(stderr,"%x: %s %s %s\n",(unsigned int)tmp,section,value,tmp);
                retval.push_back(tmp);
                tmp = new char[16];
                memset(tmp,0,16);
                i2 = 0;
            } else {
                tmp[i2] = line[i];
                ++i2;
            }
        }
        //fprintf(stderr,"%x: %s %s %s\n",(unsigned int)tmp,section,value,tmp);
        retval.push_back(tmp);
    }
    return retval;
}

/// change "foo123" to "foo"
char* stripNumbers(const char* src)
{
    char* dest;
    Uint16 i;
    for (i=0;i<strlen(src);++i) {
        if (src[i] <= '9') {
            break;
        }
    }
    dest = new char[i+1];
    strncpy(dest,src,i);
    dest[i] = 0;
    return dest;
}

char* determineBinaryLocation(char* launchcmd){
    FILE *f;
    char *path, *delim, *envpath;

    #ifdef _WIN32
    #define DIRLISTSEPARATOR ';'
    #else
    #define DIRLISTSEPARATOR ':'
    #endif
    
    f = fopen(launchcmd, "rb");
    if( f != NULL ){
        fclose(f);
        path = cppstrdup(launchcmd);
        delim = strrchr(path, '/');
#ifdef _WIN32
        delim = (char*)MAX((unsigned int)delim, (unsigned int)strrchr(path, '\\'));
#endif
        if( delim == NULL ){
            delete path;
            return cppstrdup(".");
        }
        delim[0] = '\0';
        return path;
    }

    envpath = getenv("PATH");
    path = envpath;
    while( (delim = strchr(envpath, DIRLISTSEPARATOR)) != NULL ){
	char *testcmd;
	delim[0] = '\0';
	delim++;
	
	if( path[strlen(path)-1] != '/' 
	    #ifdef _WIN32
	    && path[strlen(path)-1] != '\\'
	    #endif
	){
	    testcmd = new char[strlen(path)+strlen(launchcmd)+1];
	    sprintf(testcmd, "%s/%s", path, launchcmd);
	} else {
	    testcmd = new char[strlen(path)+strlen(launchcmd)];
	    sprintf(testcmd, "%s%s", path, launchcmd);
	}
	if( (f = fopen(testcmd, "rb")) != NULL ){
	    fclose(f);
	    path = cppstrdup(launchcmd);
	    delim = strrchr(path, '/');
	    #ifdef _WIN32
	    delim = (char*)MAX((unsigned int)delim, (unsigned int)strrchr(path, '\\'));
	    #endif
	    if( delim == NULL ){
		delete path;
		return cppstrdup(".");
	    }
	    delim[0] = '\0';
	    return path;
	}
	path = delim;
    }

    return cppstrdup(".");
}

