#include <ctype.h>
#include "cursorpool.h"
#include "inifile.h"
#include "memtrack.h"

using namespace std;

CursorPool::CursorPool(const char* ininame)
{
    if (ininame == NULL) {
        return;
    }
    cursorini = new INIFile(ininame);
    if (cursorini == NULL) {
        return;
    }
}

CursorPool::~CursorPool()
{
    delete cursorini;
    for (Uint32 i = 0; i < cursorpool.size(); ++i) {
        delete cursorpool[i];
    }
}

cursorinfo* CursorPool::getCursorByName(const char* name)
{
    map<string, Uint16>::iterator cursorentry;
    cursorinfo* datum;
    Uint16 index;

    std::string cname = (string)name;
    std::string::iterator p = cname.begin();
    while (p!=cname.end()) {
        *p = tolower(*p);
        ++p;
    }

    cursorentry = name2index.find(cname);
    if (cursorentry != name2index.end() ) {
        index = cursorentry->second;
        datum = cursorpool[index];
    } else {
        index = cursorpool.size();
        datum = new cursorinfo;
        //cursorini->seekSection(name);
        datum->anstart = cursorini->readInt(name,"start",0);
        datum->anend = cursorini->readInt(name,"end",0);
        cursorpool.push_back(datum);
        name2index[cname] = index;
    }

    return datum;
}
