#ifndef __ARCHIVE_H
#define __ARCHIVE_H

#include "SDL.h"

class VFile;

typedef VFile* (*VFSOPEN)(const char*);
typedef void (*VFSCLOSE)(VFile*);

class Archive
{
public:
    //Archive();
    virtual ~Archive()
    {}
    virtual const char *getArchiveType() = 0;
    virtual bool loadArchive(const char *fname) = 0;
    virtual void unloadArchives() = 0;
    virtual Uint32 getFile(const char *fname) = 0;
    virtual void releaseFile(Uint32 file) = 0;

    virtual Uint32 readByte(Uint32 file, Uint8 *databuf, Uint32 numBytes) = 0;
    virtual Uint32 readWord(Uint32 file, Uint16 *databuf, Uint32 numWords) = 0;
    virtual Uint32 readThree(Uint32 file, Uint32 *databuf, Uint32 numThrees) = 0;
    virtual Uint32 readDWord(Uint32 file, Uint32 *databuf, Uint32 numDWords) = 0;
    virtual char *readLine(Uint32 file, char *databuf, Uint32 buflen) = 0;

    virtual void seekSet(Uint32 file, Uint32 pos) = 0;
    virtual void seekCur(Uint32 file, Sint32 pos) = 0;

    //virtual Uint32 getStartpos(Uint32 file) = 0;
    virtual Uint32 getPos(Uint32 file) = 0;
    virtual Uint32 getSize(Uint32 file) = 0;
    //virtual FILE *getFILE(Uint32 file){return NULL;}
    virtual char *getPath(Uint32 filenum) = 0;
protected:
    VFSOPEN vfopen;
    VFSCLOSE vfclose;
};

typedef Archive* ( *PFDLLOADARCHIVE )( VFSOPEN, VFSCLOSE );

#endif

