#ifndef __EXTERNALVFS_H
#define __EXTERNALVFS_H

#ifdef _MSC_VER
# pragma warning (disable: 4503)
# pragma warning (disable: 4786)
#endif

#include <vector>
#include <map>
#include "common.h"
#include "archive.h"

typedef struct
{
    FILE *file;
    Uint32 size;
    char *path;
}
openFileExt;

class ExternalFiles : public Archive
{
public:
    ExternalFiles(char *defpath);
    ~ExternalFiles();
    const char *getArchiveType()
    {
        return "external file";
    }
    bool loadArchive(const char *fname);
    /*{
        path.push_back(cppstrdup(fname));
        return true;
    }*/
    void unloadArchives();
    Uint32 getFile(const char *fname);
    void releaseFile(Uint32 file);

    Uint32 readByte(Uint32 file, Uint8 *databuf, Uint32 numBytes);
    Uint32 readWord(Uint32 file, Uint16 *databuf, Uint32 numWords);
    Uint32 readThree(Uint32 file, Uint32 *databuf, Uint32 numThrees);
    Uint32 readDWord(Uint32 file, Uint32 *databuf, Uint32 numDWords);
    char *readLine(Uint32 file, char *databuf, Uint32 buflen);

    void seekSet(Uint32 file, Uint32 pos);
    void seekCur(Uint32 file, Sint32 pos);

    //Uint32 getStartpos(Uint32 file){return 0;}
    Uint32 getPos(Uint32 file);
    Uint32 getSize(Uint32 file);
    //FILE *getFILE(Uint32 file);
    char *getPath(Uint32 file);
private: 
    char *defpath;
    std::vector<char*> path;
    std::map<Uint32, openFileExt> openFiles;
};

#endif

